/*
 * RoundList.cpp
 *
 *  Created on: Mar 14, 2011
 *      Author: vikturek
 */

/*

Implementujte datovou strukturu, ktera bude implementovat kruhovy
linearni spojovy seznam. Mel by mit interni ukazatel na aktualni prvek
a metody pro vkladani, vybirani hodnot typu integer, pro posun
ukazatele na dalsi prvek a metodu pro nastaveni interniho ukazatele
na prvni element.

*/

#include <iostream>

// Struktura pro ulozeni hodnoty
struct Element{
    int value;
// Ukazatel na dalsi prvek v seznamu
    Element *next;
};

// Trida obsahujici rozhrani pro kruhovy seznam
class RoundList{
// Ukazatel na pocatecni prvek seznamu
    Element *_root;
// Ukazatel na aktualni prvek seznamu
    Element *current;
public:
// Konstruktor
    RoundList(){
// Pokud nejsou pouzity okamzite, je dobre nastavit
// promenne typu ukazatel na NULL. Je to jediny
// zpusob jak pozdeji poznat, ze nikam neukazuji.
	_root = NULL;
	current = NULL;
    }
// Metoda vlozi hovou hodnotu do listu.
    void push(int c){
// Pokud je seznam prazdny, je vytvoren novy element jako zaklad.
	if(_root == NULL){
	    _root = new Element;
	    _root->value = c;
// Dalsi prvek v listu je prvek sam.
	    _root->next = _root;
	    current = _root;
	} else {
// Vlozi novy prvek za aktualni prvek
	    Element *tmp = current->next;
	    current->next = new Element;
	    current->next->next = tmp;
	    current->next->value = c;
	}
    }
// Vybere prvek z listu z aktualni pozice
    int pop(){
    	int ret = current->value;
    	Element *tmp = current;

    	if(current->next == current){
    		delete current;
    		return ret;
    	}

    	while(tmp->next != current){
    		tmp = tmp->next;
    	}
    	tmp->next = current->next;
    	delete current;
    	return ret;
    }
// Posun ukazatele na dalsi prvek a zaroven vraci hodnotu
// interniho ukazatele.
    Element *next(){
		current = current->next;
		return current;
    }
    Element *root(){
    	current = _root;
    	return _root;
    }

};

int main(){

    return 0;
}
